<script lang="ts">
import Vue from 'vue';

export default Vue.extend({
  name: 'HeroCard',
  components: {},
  props: {
    data: {
      type: Object,
      required: true,
      default: null,
    },
  },
  data() {
    return {};
  },
  methods: {},
});
</script>

<template>
  <div :class="`hero-card__wrapper hero-card--${data.type}`">
    <a
      :href="data.button?.link || data.primaryButton?.link"
      class="hero-card slp-mb-lg-32"
      :class="`hero-card--${data.theme}`"
      :data-ga-name="
        data.button?.data_ga_name || data.primaryButton?.data_ga_name
      "
      :data-ga-location="
        data.button?.data_ga_location || data.primaryButton?.data_ga_location
      "
    >
      <img
        alt=""
        :src="data.image.src"
        class="slp-mb-16 hero-card__image"
        preload
      />
      <SlpPillButton
        v-if="data.subtitle"
        type="true"
        class="slp-mt-16 hero-card__pill"
      >
        {{ data.subtitle }}
      </SlpPillButton>
      <SlpTypography
        tag="h2"
        variant="heading5-bold"
        class="slp-mb-16 hero-card__blurb"
      >
        {{ data.title }}
      </SlpTypography>
      <SlpButton variant="tertiary" class="hero-card__button">
        {{ data.button?.text ? data.button.text : data.primaryButton?.text }}
        <SlpIcon name="chevron-lg-right" variant="product" />
      </SlpButton>
    </a>
    <div v-if="data.type === 'slide'" class="hero-card__slide">
      <div class="hero-card__item--block hero-card__content-block">
        <SlpTypography tag="h1" variant="heading2-bold">{{
          data.blurb
        }}</SlpTypography>

        <SlpTypography tag="h2" variant="body1" class="subtitle slp-my-16">
          <span v-html="data.title"></span>
        </SlpTypography>

        <div class="slp-mb-16 slp-mt-24">
          <SlpButton
            v-if="data.secondaryButton?.link"
            variant="primary"
            :data-ga-name="data.secondaryButton.data_ga_name"
            :data-ga-location="data.secondaryButton.data_ga_location"
            :href="data.secondaryButton.link"
            class="slp-mr-16"
            >{{ data.secondaryButton.text }}
          </SlpButton>
          <SlpButton
            v-if="data.primaryButton?.link"
            variant="tertiary"
            class="homepage-hero__secondary-button"
            :href="data.primaryButton.link"
            :data-ga-name="data.primaryButton.data_ga_name"
            :data-ga-location="data.primaryButton.data_ga_location"
            >{{ data.primaryButton.text }}
            <SlpIcon name="chevron-lg-right" variant="product" />
          </SlpButton>
        </div>
      </div>

      <div class="hero-card__item--image">
        <img alt="" :src="data.image.src" class="slp-mb-16" preload />
      </div>
    </div>
  </div>
</template>

<style lang="scss" scoped>
.hero-card {
  border-radius: 8px;
  background: linear-gradient(
    176deg,
    rgba(255, 255, 255, 0.75) 0%,
    rgba(255, 255, 255, 0.4) 100%
  );
  width: 100%;
  max-width: 460px;
  border-radius: 9px;
  overflow: hidden;
  margin-right: 40px;
  padding: $spacing-24;
  transition: transform 0.3s ease;
  height: 100%;
  display: flex;
  flex-direction: column;
  .hero-card__button {
    color: #000;
  }
  &:hover {
    transform: translateY(-10px);
    cursor: pointer;
    .hero-card__button {
      text-decoration-color: currentColor !important;
      :deep .slp-icon {
        transform: translateX(8px);
      }
    }
  }
  &--dark {
    background: rgba(23, 19, 33, 0.9);
    .hero-card__blurb {
      color: $color-primary-300;
    }
    .hero-card__button {
      color: #fff;
      &:hover {
        text-decoration-color: currentColor !important;
      }
    }
  }
  &__blurb {
    padding: $spacing-24 0 0;
    color: $color-secondary-300;
  }
  &__button {
    color: $color-text-link-100;
    margin: auto 0 0;
    &:hover {
      text-decoration-color: currentColor !important;
    }
  }
  &__image {
    max-height: 260px;
    object-fit: cover;
    object-position: top;
    width: 100%;
  }
  &__wrapper {
    height: 100%;
  }
  &__slide {
    display: none;
    @media (min-width: $breakpoint-md) {
      display: flex;
    }

    @media (min-width: 2560px) {
      display: none;
    }
  }
  &--slide {
    .hero-card {
      display: block;
      @media (min-width: $breakpoint-md) {
        display: none;
      }
      @media (min-width: 2560px) {
        display: block;
      }
    }

    .hero-card__item--image {
      flex: 0 0 100%;
      margin: 0;
      max-width: 100%;
      display: none;
      :deep img {
        object-fit: cover;
        width: 100%;
      }
      @media (min-width: $breakpoint-md) {
        flex: 0 0 50%;
        display: block;
      }
      @media (min-width: $breakpoint-xl) {
        flex: 0 0 calc(1170px / 2);
      }
    }
    .hero-card__item--block {
      display: none;
      margin-right: 40px;
      flex: 0 0 90%;
      max-width: 460px;

      @media (min-width: $breakpoint-md) {
        flex: 0 0 50%;
        display: block;
        max-width: 100%;
        margin-right: 0;
        @media (min-width: $breakpoint-xl) {
          flex: 0 0 calc(1170px / 2);
          margin-left: 64px;
        }
      }
    }
  }
  &__content-block {
    width: 100%;

    margin-top: 64px;
    @media (min-width: $breakpoint-md) {
      max-width: 460px;
      margin-right: 40px;
    }
    :deep .slp-btn {
      width: 100%;
      justify-content: center;
      margin-top: 16px;
      @media (min-width: $breakpoint-md) {
        width: inherit;
        justify-content: unset;
      }
    }
  }
  &__pill {
    padding: 4px 12px;
    :deep {
      .slp-icon {
        display: none;
      }
    }
    + .hero-card__blurb {
      padding-top: $spacing-8;
    }
  }
}
</style>
